{-# LANGUAGE DeriveDataTypeable #-}
{-# OPTIONS_GHC -fno-cse #-}
{-
Module      :  $Header$
Description :  Main
Copyright   :  (c) SMART Team / HASLab
License     :  GPL

Maintainer  :  Paulo Silva <paufil@di.uminho.pt>
Stability   :  experimental
Portability :  non-portable

-}

module Main where

import Main.Flags
import Main.Compiler

main :: IO ()
main = do
    opts <- getOpts
    case opts of
        Help     -> printHelp
        Comp  {} -> caoComp  opts
